## xmlrpc-c 1.06.21

=== lib/Makefile ===
ifeq ($(SRCDIR)x,x)
SRCDIR = $(CURDIR)/..
endif
SUBDIR = lib

include $(SRCDIR)/Makefile.config

# Build up SUBDIRS:
SUBDIRS = 
SUBDIRS += util libutil
ifeq ($(ENABLE_ABYSS_SERVER),yes)
  SUBDIRS += abyss
endif
ifeq ($(MUST_BUILD_WININET_CLIENT),yes)
  SUBDIRS += wininet_transport
endif
ifeq ($(MUST_BUILD_CURL_CLIENT),yes)
  SUBDIRS += curl_transport
endif
ifeq ($(MUST_BUILD_LIBWWW_CLIENT),yes)
  SUBDIRS += libwww_transport
endif
ifneq ($(ENABLE_LIBXML2_BACKEND),yes)
  SUBDIRS += expat
endif

default: all

.PHONY: all clean distclean tags distdir intall check dep

all: $(SUBDIRS:%=%/all)

clean: $(SUBDIRS:%=%/clean) clean-common

distclean: $(SUBDIRS:%=%/distclean) distclean-common

tags: $(SUBDIRS:%=%/tags) TAGS

DISTFILES = 

distdir: distdir-common

install: $(SUBDIRS:%=%/install)

check:

dep: $(SUBDIRS:%=%/dep)

include $(SRCDIR)/Makefile.common

=== src/Makefile ===
ifeq ($(SRCDIR)x,x)
SRCDIR = $(CURDIR)/..
endif
SUBDIR = src
BUILDDIR = $(SRCDIR)
VPATH = .:$(SRCDIR)

include $(BUILDDIR)/Makefile.config

ABYSS_LIBDIR = $(BUILDDIR)/lib/abyss/src/.libs
LIBUTIL_LIBDIR = $(BUILDDIR)/lib/libutil/.libs

default: all

SUBDIRS =

ifeq ($(ENABLE_CPLUSPLUS),yes)
  SUBDIRS += cpp
endif

WININET_TRANSPORT_DIR = $(SRCDIR)/lib/wininet_transport
CURL_TRANSPORT_DIR    = $(SRCDIR)/lib/curl_transport
LIBWWW_TRANSPORT_DIR  = $(SRCDIR)/lib/libwww_transport

# TRANSPORT_OBJS is the list of modules that have to go into the client
# library to provide the client XML transport functions.  Since there is
# some variability in what XML transports we can build into the client
# library, this is a little complicated.

# TRANSPORT_LIBDEP is linker -l options to declare what libraries contain
# things to which the transport objects refer.  (like LIBxxx_LIBDEP --
# see below)

TRANSPORT_OBJS =
TRANSPORT_LIBDEP =
ifeq ($(MUST_BUILD_WININET_CLIENT),yes)
  TRANSPORT_OBJS += $(WININET_TRANSPORT_DIR)/xmlrpc_wininet_transport.lo
  TRANSPORT_LIBDEP += $(shell wininet-config --libs)
endif
ifeq ($(MUST_BUILD_CURL_CLIENT),yes)
  TRANSPORT_OBJS += $(CURL_TRANSPORT_DIR)/xmlrpc_curl_transport.lo
  TRANSPORT_LIBDEP += $(shell curl-config --libs)
endif
ifeq ($(MUST_BUILD_LIBWWW_CLIENT),yes)
  TRANSPORT_OBJS += $(LIBWWW_TRANSPORT_DIR)/xmlrpc_libwww_transport.lo
  TRANSPORT_LIBDEP += $(shell libwww-config --libs)
endif

ifeq ($(ENABLE_LIBXML2_BACKEND),yes)
  LIBXML_INCLUDES = $(shell xml2-config --cflags)
else
  LIBXML_INCLUDES = -I$(SRCDIR)/lib/expat/xmlparse
endif

ABYSS_INCLUDES = -I$(SRCDIR)/lib/abyss/src

ifeq ($(ENABLE_LIBXML2_BACKEND),yes)
  XMLRPC_XML_PARSER = xmlrpc_libxml2.lo
else
  XMLRPC_XML_PARSER = xmlrpc_expat.lo
endif

# LIBxxx_OBJS is the list of object files that make up library libxxx.

# LIBxxx_LIBDEP is linker -l options to declare what libraries contain
# things to which the library being built refers.  This information
# makes its way to the dynamic linker, so it knows to load the
# referred-to library before it loads libxxx.  Note that the link command
# may require the necessary -L options in addition.

LIBXMLRPC_CLIENT_OBJS = xmlrpc_client.lo xmlrpc_client_global.lo
LIBXMLRPC_CLIENT_LIBDEP = -lxmlrpc_util -lxmlrpc

LIBXMLRPC_SERVER_OBJS = registry.lo system_method.lo
LIBXMLRPC_SERVER_LIBDEP = -lxmlrpc_util -lxmlrpc

LIBXMLRPC_SERVER_ABYSS_OBJS = xmlrpc_server_abyss.lo
LIBXMLRPC_SERVER_ABYSS_LIBDEP = \
  -lxmlrpc_util -lxmlrpc_server -L$(ABYSS_LIBDIR) -lxmlrpc_abyss -lxmlrpc

LIBXMLRPC_SERVER_CGI_OBJS = xmlrpc_server_cgi.lo
LIBXMLRPC_SERVER_CGI_LIBDEP = -lxmlrpc_util -lxmlrpc_server -lxmlrpc

LIBXMLRPC_OBJS = \
	trace.lo \
	xmlrpc_data.lo \
	xmlrpc_builddecomp.lo \
	xmlrpc_datetime.lo \
	xmlrpc_array.lo \
	xmlrpc_struct.lo \
	$(XMLRPC_XML_PARSER) \
	xmlrpc_parse.lo \
	xmlrpc_serialize.lo \
	xmlrpc_base64.lo \
	xmlrpc_utf8.lo \
	xmlrpc_authcookie.lo \

LIBXMLRPC_LIBDEP = -lxmlrpc_util

LIB_OBJS = $(LIBXMLRPC_CLIENT_OBJS) $(LIBXMLRPC_SERVER_OBJS)

TRANSPORT_INCLUDES = \
  -I$(WININET_TRANSPORT_DIR) \
  -I$(CURL_TRANSPORT_DIR) \
  -I$(LIBWWW_TRANSPORT_DIR) \

INCLUDES = -I$(BUILDDIR) -I$(SRCDIR) \
           -I$(SRCDIR)/include -I$(SRCDIR)/lib/util/include \
	   -I$(SRCDIR)/lib/abyss/src \
	   $(TRANSPORT_INCLUDES) \
	   $(LIBXML_INCLUDES) \

# People sometimes think that when the Xmlrpc-c build has been
# configured for no Abyss server (configure --disable-abyss), that
# libmxlrpc_server_abyss should not get built.  But
# libxmlrpc_server_abyss is not part of the Abyss server; it is merely
# some code that exploits an Abyss server, and you don't need to have a
# built Abyss server to build it.

TARGET_LTLIBRARIES = libxmlrpc.la libxmlrpc_server.la \
     libxmlrpc_server_abyss.la

ifeq ($(MUST_BUILD_CLIENT),yes)
  TARGET_LTLIBRARIES += libxmlrpc_client.la
endif

ifeq ($(ENABLE_CGI_SERVER),yes)
  TARGET_LTLIBRARIES += libxmlrpc_server_cgi.la
endif

all: $(TARGET_LTLIBRARIES) $(SUBDIRS:%=%/all)

LDFLAGS = $(LADD)

LIBPATHS = -L.libs -L$(LIBUTIL_LIBDIR)

LIBLDFLAGS = $(LDFLAGS_VERSINFO) -rpath $(LIBINST_DIR) $(LIBPATHS) $(LADD)


libxmlrpc.la: $(LIBXMLRPC_OBJS)
	$(LIBTOOL) --mode=link $(CCLD) -o $@ $(LIBLDFLAGS) \
	  $(LIBXMLRPC_OBJS) $(LIBXMLRPC_LIBDEP) 

libxmlrpc_client.la: $(LIBXMLRPC_CLIENT_OBJS) $(TRANSPORT_OBJS)
	$(LIBTOOL) --mode=link $(CCLD) -o $@ $(LIBLDFLAGS) \
	  $(LIBXMLRPC_CLIENT_OBJS) $(TRANSPORT_OBJS) \
	  $(LIBXMLRPC_CLIENT_LIBDEP) $(TRANSPORT_LIBDEP) \

libxmlrpc_server.la: $(LIBXMLRPC_SERVER_OBJS)
	$(LIBTOOL) --mode=link $(CCLD) -o $@ $(LIBLDFLAGS) \
	  $(LIBXMLRPC_SERVER_OBJS) $(LIBXMLRPC_SERVER_LIBDEP)

libxmlrpc_server_abyss.la: $(LIBXMLRPC_SERVER_ABYSS_OBJS)
	$(LIBTOOL) --mode=link $(CCLD) -o $@ $(LIBLDFLAGS) \
	  $(LIBXMLRPC_SERVER_ABYSS_OBJS) $(LIBXMLRPC_SERVER_ABYSS_LIBDEP)

libxmlrpc_server_cgi.la: $(LIBXMLRPC_SERVER_CGI_OBJS)
	$(LIBTOOL) --mode=link $(CCLD) -o $@ $(LIBLDFLAGS) \
	  $(LIBXMLRPC_SERVER_CGI_OBJS) $(LIBXMLRPC_SERVER_CGI_LIBDEP)


CFLAGS = $(CFLAGS_COMMON) $(CFLAGS_PERSONAL) $(CADD)

$(LIBXMLRPC_CLIENT_OBJS) $(LIBXMLRPC_SERVER_OBJS):%.lo:%.c
	$(LIBTOOL) --mode=compile $(CC) -c $(INCLUDES) $(CFLAGS) $<

$(LIBXMLRPC_OBJS):%.lo:%.c
	$(LIBTOOL) --mode=compile $(CC) -c $(INCLUDES) $(LIBXML_INCLUDES) \
	  $(CFLAGS) $<

$(LIBXMLRPC_SERVER_ABYSS_OBJS):%.lo:%.c
	$(LIBTOOL) --mode=compile $(CC) -c $(INCLUDES) $(ABYSS_INCLUDES) \
	  $(CFLAGS) $<

xmlrpc_server_cgi.lo:%.lo:%.c
	$(LIBTOOL) --mode=compile $(CC) -c $(INCLUDES) \
	  $(CFLAGS) $<

LTLIBRARIES_TO_INSTALL = $(TARGET_LTLIBRARIES)

check:
	$(MAKE) -C test runtests
	$(MAKE) -C cpp  check

.PHONY: install
install: install-common $(SUBDIRS:%=%/install)

.PHONY: clean clean-local distclean
clean: clean-common clean-local $(SUBDIRS:%=%/clean)
clean-local:
	$(MAKE) -C test clean

distclean: clean-common clean-local distclean-common $(SUBDIRS:%=%/distclean)

.PHONY: dep
dep: $(SUBDIRS:%=%/dep) $(BUILDDIR)/transport_config.h dep-common

include $(SRCDIR)/Makefile.common

xmlrpc_client.lo: $(BUILDDIR)/transport_config.h

include Makefile.depend

=== lib/libutil/Makefile ===
###############################################################################
# This directory builds libxmlrpc_util, which contains utility
# functions that are used by the Xmlprc-c # libraries, and also
# directly by Xmlrpc-c programs.
#
# The functions in this library are characterized by being general purpose
# programming functions, such as one might wish were in the standard C
# library, which have nothing in particular to do with XML-RPC.
###############################################################################

ifeq ($(SRCDIR)x,x)
SRCDIR = $(CURDIR)/../..
endif
SUBDIR = lib/libutil
# BLDDIR is for use in places where a symbolic link won't work.
# BUILDDIR is for places in Makefile.common that can use the 'blddir'
# symbolic link (but in other directories, doesn't).
BLDDIR = ../..
BUILDDIR = blddir
VPATH = .:$(SRCDIR)

include $(BLDDIR)/Makefile.config

default: all

all: libxmlrpc_util.la

LIBXMLRPC_UTIL_OBJS = \
  casprintf.lo \
  error.lo \
  make_printable.lo \
  memblock.lo \
  resource.lo \
  sleep.lo \

INCLUDES = -Iblddir -I$(SRCDIR) \
           -Isrcdir/include -Isrcdir/lib/util/include

LDFLAGS = $(LADD)

LIBLDFLAGS = $(LDFLAGS_VERSINFO) -rpath $(LIBINST_DIR) $(LADD)

libxmlrpc_util.la: $(LIBXMLRPC_UTIL_OBJS)
	$(LIBTOOL) --mode=link $(CCLD) -o $@ $(LIBLDFLAGS) $^

CFLAGS = $(CFLAGS_COMMON) $(CFLAGS_PERSONAL) $(CADD)

$(LIBXMLRPC_UTIL_OBJS):%.lo:%.c
	$(LIBTOOL) --mode=compile $(CC) -c $(INCLUDES) $(CFLAGS) $<

LTLIBRARIES_TO_INSTALL = libxmlrpc_util.la

.PHONY: install
install: install-common

.PHONY: clean distclean
clean: clean-common

distclean: clean distclean-common

.PHONY: dep
dep: dep-common

# This 'Makefile.common' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/Makefile.common: srcdir blddir

include $(SRCDIR)/Makefile.common

include Makefile.depend

=== lib/util/Makefile ===
###############################################################################
# This directory builds object modules that provide utility functions that
# programs can use.  Not libraries, though -- just programs.  The reason
# we don't want any library to use object modules in here is that they'll
# probably pollute the name space when users link those libraries to their
# programs.  In fact, if more than one Xmlrpc-c library includes one of these
# modules, the libraries will conflict with each other.
#
# So a utility function that is to be used by libraries (and, optionally,
# programs) should go in libxmlrpc_util.  libxmlrpc_util is a prerequisite
# for many Xmlrpc-c libraries, gets included in a program link only once,
# and uses external symbol names that have the "xmlrpc_" prefix to avoid
# collision with users' code.
#
# If we knew a portable way to link multiple object modules into one and
# restrict the symbols exported by the whole, we could avoid this mess and
# just link utility object modules into each Xmlrpc-c library.
##############################################################################

ifeq ($(SRCDIR)x,x)
SRCDIR = $(CURDIR)/../..
endif
SUBDIR = lib/util
BUILDDIR = $(SRCDIR)

default: all

include $(BUILDDIR)/Makefile.config

include $(SRCDIR)/Makefile.common

.PHONY: all
all: cmdline_parser.lo getoptx.lo casprintf.lo

INCLUDES = -Iinclude -I$(BUILDDIR)

CFLAGS = $(CFLAGS_COMMON) $(INCLUDES) $(CFLAGS_PERSONAL) $(CADD)

%.lo:%.c
	$(LIBTOOL) --mode=compile $(CC) -c $(CFLAGS) $<

include Makefile.depend

.PHONY: clean distclean
clean: clean-common

distclean: clean distclean-common

.PHONY: dep
dep: dep-common

install:

=== src/cpp/Makefile ===
ifeq ($(SRCDIR)x,x)
SRCDIR := $(CURDIR)/../..
endif
SUBDIR := src/cpp
# BLDDIR is for use in places where a symbolic link won't work.
# BUILDDIR is for places in Makefile.common that can use the 'blddir'
# symbolic link (but in directories that don't, like this one, have
# blddir, these places use something else -- hence the variable).
BLDDIR = ../..
BUILDDIR := blddir
VPATH = .:$(SRCDIR)

include $(BLDDIR)/Makefile.config

default: all

# libxmlrpc_cpp is the legacy C++ wrapper library.  The others are the
# more elaborate replacements.

TARGET_LIBRARY_NAMES := \
  libxmlrpc_cpp \
  libxmlrpc++ \
  libxmlrpc_server++ \
  libxmlrpc_server_abyss++ \

ifeq ($(MUST_BUILD_CLIENT),yes)
  TARGET_LIBRARY_NAMES += libxmlrpc_client++
endif

STATIC_LIBRARIES_TO_INSTALL = $(TARGET_STATIC_LIBRARIES)

SHARED_LIBS_TO_BUILD := $(TARGET_LIBRARY_NAMES)
SHARED_LIBS_TO_INSTALL := $(TARGET_LIBRARY_NAMES)

# INCLUDES and DEP_SOURCES are used by dep-common target
INCLUDES = $(BASIC_INCLUDES) $(CLIENT_INCLUDES) $(LIBXML_INCLUDES) \
  $(SERVER_INCLUDES) $(SERVER_ABYSS_INCLUDES) $(TRANSPORT_INCLUDES)
DEP_SOURCES = *.cpp

WININET_TRANSPORT_DIR = srcdir/lib/wininet_transport
CURL_TRANSPORT_DIR    = srcdir/lib/curl_transport
LIBWWW_TRANSPORT_DIR  = srcdir/lib/libwww_transport

ifeq ($(ENABLE_LIBXML2_BACKEND),yes)
  LIBXML_INCLUDES = $(LIBXML2_CFLAGS)
else
  LIBXML_INCLUDES = -Isrcdir/lib/expat/xmlparse
endif

LIBXMLRPCPP_OBJS = \
	base64.o \
	env_wrap.o \
	fault.o \
	girerr.o \
	girmem.o \
	outcome.o \
	param_list.o \
	value.o \
	xml.o \

LIBXMLRPC_SERVERPP_OBJS = registry.o
LIBXMLRPC_SERVER_ABYSSPP_OBJS = server_abyss.o
LIBXMLRPC_CLIENTPP_OBJS = client.o client_simple.o curl.o libwww.o wininet.o

ALL_OBJS = \
  XmlRpcCpp.o \
  $(LIBXMLRPCCPP_OBJS) \
  $(LIBXMLRPC_SERVERPP_OBJS) \
  $(LIBXMLRPC_SERVER_ABYSSPP_OBJS) \
  $(LIBXMLRPC_CLIENTPP_OBJS)

include $(SRCDIR)/Makefile.common

# This 'Makefile.common' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/Makefile.common: srcdir blddir

TRANSPORT_INCLUDES = \
  -I$(WININET_TRANSPORT_DIR) \
  -I$(CURL_TRANSPORT_DIR) \
  -I$(LIBWWW_TRANSPORT_DIR) \

BASIC_INCLUDES = -Isrcdir/include -Iblddir -Isrcdir \
  -Isrcdir/lib/util/include

ifeq ($(SHARED_LIB_TYPE),unix)
  include unix.make
  endif

ifeq ($(SHARED_LIB_TYPE),irix)
  include irix.make
  endif

ifeq ($(SHARED_LIB_TYPE),dll)
  include dll.make
  endif

ifeq ($(SHARED_LIB_TYPE),dylib)
  include dylib.make
  endif

ifneq ($(SHARED_LIB_TYPE),NONE)
  TARGET_SHARED_LIBRARIES = $(TARGET_LIBRARY_NAMES:%=%.$(SHLIB_SUFFIX))
  endif

TARGET_STATIC_LIBRARIES = $(TARGET_LIBRARY_NAMES:%=%.a)

TARGET_LIBRARIES = $(TARGET_STATIC_LIBRARIES) $(ALL_SHARED_LIBRARIES)

all: $(TARGET_LIBRARIES)

libxmlrpc_cpp.a: XmlRpcCpp.o
	-rm -f $@
	$(AR) cru $@ $^
	$(RANLIB) $@

libxmlrpc++.a: $(LIBXMLRPCPP_OBJS)
	-rm -f $@
	$(AR) cru $@ $^
	$(RANLIB) $@

libxmlrpc_server++.a: $(LIBXMLRPC_SERVERPP_OBJS)
	-rm -f $@
	$(AR) cru $@ $^
	$(RANLIB) $@

libxmlrpc_server_abyss++.a: $(LIBXMLRPC_SERVER_ABYSSPP_OBJS)
	-rm -f $@
	$(AR) cru $@ $^
	$(RANLIB) $@

libxmlrpc_client++.a: $(LIBXMLRPC_CLIENTPP_OBJS)
	-rm -f $@
	$(AR) cru $@ $^
	$(RANLIB) $@

#-----------------------------------------------------------------------------
#  RULES TO COMPILE OBJECT MODULES FOR LIBRARIES
#-----------------------------------------------------------------------------

CXXFLAGS = $(CXXFLAGS_COMMON) $(CFLAGS_PERSONAL) $(CADD)

XmlRpcCpp.o:%.o:%.cpp
	$(CXX) -c $(BASIC_INCLUDES) $(CXXFLAGS) $<

$(LIBXMLRPCPP_OBJS):%.o:%.cpp
	$(CXX) -c $(BASIC_INCLUDES) $(CXXFLAGS) $<

SERVER_INCLUDES = $(BASIC_INCLUDES) $(LIBXML_INCLUDES)

$(LIBXMLRPC_SERVERPP_OBJS):%.o:%.cpp
	$(CXX) -c $(SERVER_INCLUDES) $(CXXFLAGS) $<

SERVER_ABYSS_INCLUDES = $(SERVER_INCLUDES) -Isrcdir/lib/abyss/src

$(LIBXMLRPC_SERVER_ABYSSPP_OBJS):%.o:%.cpp
	$(CXX) -c $(SERVER_ABYSS_INCLUDES) $(CXXFLAGS) $<

CLIENT_INCLUDES = $(BASIC_INCLUDES) $(LIBXML_INCLUDES) $(TRANSPORT_INCLUDES)

$(LIBXMLRPC_CLIENTPP_OBJS):%.o:%.cpp
	$(CXX) -c $(CLIENT_INCLUDES) $(CXXFLAGS) $<

client.o curl.o libwww.o wininet.o: $(BUILDDIR)/transport_config.h

#-----------------------------------------------------------------------------
#  MISCELLANEOUS RULES
#-----------------------------------------------------------------------------

check:
	$(MAKE) -C test runtests

.PHONY: install
install: install-common

.PHONY: clean clean-local distclean distclean-local
clean: clean-common clean-local
clean-local:
	$(MAKE) -C test clean

distclean: clean distclean-local distclean-common

distclean-local:
	$(MAKE) -C test distclean

.PHONY: dep
dep: dep-common $(BUILDDIR)/transport_config.h

include Makefile.depend

=== tools/xmlrpc/Makefile ===
ifeq ($(SRCDIR)x,x)
SRCDIR = $(CURDIR)/../..
endif
# BLDDIR is for use in places where a symbolic link won't work.
# BUILDDIR is for places in Makefile.common that can use the 'blddir'
# symbolic link (but in other directories, doesn't).
BLDDIR = $(SRCDIR)
BUILDDIR = blddir

default: all

include $(BLDDIR)/Makefile.config

PROGRAMS_TO_INSTALL = xmlrpc

include ../Makefile.common

INCLUDES = -I$(SRCDIR) -I$(SRCDIR)/include -I$(SRCDIR)/lib/util/include

CFLAGS = $(CFLAGS_COMMON) $(INCLUDES) $(CFLAGS_PERSONAL) $(CADD)

LDFLAGS = $(LADD)

all: xmlrpc

UTIL_OBJS = cmdline_parser.o getoptx.o casprintf.o
UTILS = $(UTIL_OBJS:%=$(UTIL_DIR)/%)

# These are the Libtool .la files.  We use them only for make dependencies.
# We'd like to use these in the link rule, by using libtool --link, but
# Libtool adds -l options to the link to cover the dependencies that are
# recorded inside the shared libraries.  And it doesn't add the necessary
# -L options (it can't), so we end up with a messy mixture of the two
# forms of specifying libraries.

LIBS = $(LIBXMLRPC_CLIENT) $(LIBXMLRPC) $(LIBXMLRPC_XML) $(LIBXMLRPC_UTIL)

XMLRPC_OBJS = xmlrpc.o dumpvalue.o

xmlrpc: $(XMLRPC_OBJS) $(LIBS) $(UTILS)
	$(CCLD) -o $@ $(LDFLAGS) $(XMLRPC_OBJS) $(UTILS) $(CLIENT_LDLIBS)

%.o:%.c
	$(CC) -c $(CFLAGS) $<

*.c: config.h

config.h:
	$(LN_S) $(BLDDIR)/xmlrpc_config.h $@

# This Makefile.config dependency makes sure the symlinks get built before
# this make file is used for anything.

$(BLDDIR)/Makefile.config: blddir srcdir

include Makefile.depend

.PHONY: dep
dep: dep-common

.PHONY: clean
clean: clean-common
	rm -f xmlrpc config.h

.PHONY: distclean
distclean: clean distclean-common

=== tools/xmlrpc_transport/Makefile ===
ifeq ($(SRCDIR)x,x)
SRCDIR = $(CURDIR)/../..
endif
# BLDDIR is for use in places where a symbolic link won't work.
# BUILDDIR is for places in Makefile.common that can use the 'blddir'
# symbolic link (but in other directories, doesn't).
BLDDIR = $(SRCDIR)
BUILDDIR = blddir

default: all

include $(BLDDIR)/Makefile.config

PROGRAMS_TO_INSTALL = xmlrpc_transport

include ../Makefile.common

INCLUDES = -I$(SRCDIR) -I$(SRCDIR)/include -I$(SRCDIR)/lib/util/include

CFLAGS = $(CFLAGS_COMMON) $(INCLUDES) $(CFLAGS_PERSONAL) $(CADD)

LDFLAGS = $(LADD)

all: xmlrpc_transport

UTIL_OBJS = cmdline_parser.o getoptx.o casprintf.o
UTILS = $(UTIL_OBJS:%=$(UTIL_DIR)/%)

# These are the Libtool .la files.  We use them only for make dependencies.
# We'd like to use these in the link rule, by using libtool --link, but
# Libtool adds -l options to the link to cover the dependencies that are
# recorded inside the shared libraries.  And it doesn't add the necessary
# -L options (it can't), so we end up with a messy mixture of the two
# forms of specifying libraries.

LIBS = $(LIBXMLRPC_CLIENT) $(LIBXMLRPC) $(LIBXMLRPC_XML) $(LIBXMLRPC_UTIL)

xmlrpc_transport:%:%.o $(LIBS) $(UTILS)
	$(CCLD) -o $@ $(LDFLAGS) $< $(CLIENT_LDLIBS) $(UTILS)

%.o:%.c
	$(CC) -c $(CFLAGS) $<

*.c: config.h

config.h:
	$(LN_S) $(BLDDIR)/xmlrpc_config.h $@

# This Makefile.config dependency makes sure the symlinks get built before
# this make file is used for anything.

$(BLDDIR)/Makefile.config: blddir srcdir

include Makefile.depend

.PHONY: dep
dep: dep-common

.PHONY: clean
clean: clean-common
	rm -f xmlrpc_transport config.h

.PHONY: distclean
distclean: clean distclean-common

=== lib/expat/gennmtab/Makefile ===
ifeq ($(SRCDIR)x,x)
SRCDIR = $(CURDIR)/../../..
endif

include $(SRCDIR)/Makefile.config

CFLAGS = $(CFLAGS_COMMON) $(CFLAGS_PERSONAL) $(CADD)

LDFLAGS = $(LADD)

INCLUDES = -I$(SRCDIR) -I$(SRCDIR)/lib/util/include

default: all

include $(SRCDIR)/Makefile.common

.PHONY: all
all: gennmtab

.PHONY: clean
clean: clean-common
	rm -f gennmtab

.PHONY: distclean
distclean: clean distclean-common

.PHONY: tags
tags: TAGS

.PHONY: distdir
distdir:

.PHONY: install
install:

.PHONY: dep
dep: dep-common

gennmtab.o:%.o:%.c
	$(BUILDTOOL_CC) -c $< -o $@ $(CFLAGS) $(INCLUDES)

gennmtab:%:%.o
	$(BUILDTOOL_CCLD) -o $@ $(LDFLAGS) $^

include Makefile.depend

## xmlrpc-c 1.06.25-2irreco1

=== debian/changelog ===
xmlrpc-c (1.06.25-2irreco1) unstable; urgency=low

  * Based on 1.06.25-2 from Debian.
  * Linked against libwww because curl is too old in Maemo.
  * Linked against libxml2 instead of built-in expat.

 -- Arto Karppinen <arto.karppinen@iki.fi>  Fri, 11 Apr 2008 11:05:23 +0300

xmlrpc-c (1.06.25-2) unstable; urgency=low

  * disable building of libwww client, removing all dependencies on the
    libwww packages, as they are buggy and will be removed from debian.
    thanks to Regis Boudin for the patch (closes: #458775).
  * start build-depending on (and using) quilt for add-on patch management.
  * new patch: old-libtool, fixing FTBFS on kfreebsd-gnu.  thanks to 
    Petr Salinger (closes: #466054).

 -- Sean Finney <seanius@debian.org>  Thu, 20 Mar 2008 08:35:02 +0100

xmlrpc-c (1.06.25-1) unstable; urgency=low

  * New Upstream Version
  * Bump Standards-Version to 3.7.3
  * debian/rules cleanup, add autotools-dev to build-deps.

 -- Sean Finney <seanius@debian.org>  Thu, 13 Mar 2008 23:56:29 +0100

xmlrpc-c (1.06.21-3) unstable; urgency=low

  * re-upload due to ftp-master outage.
  * change build-deps for curl to libcurl4-openssl-dev | libcurl3-openssl-dev, 
    to facilitate easier backporting to etch.

 -- Sean Finney <seanius@debian.org>  Mon, 28 Jan 2008 21:57:45 +0100

xmlrpc-c (1.06.21-1) unstable; urgency=low

  * new upstream release
  * Wasn't building with curl support, needed to add libcurl4-openssl-dev
    to the list of build-dependencies.  Thanks to Bas van Sisseren for 
    catching this (closes: #309954).

 -- Sean Finney <seanius@debian.org>  Sat, 03 Nov 2007 18:46:58 +0100

xmlrpc-c (1.06.17-0ubuntu4) gutsy; urgency=low

  * libxmlrpc-c3-dev: 
    -> Fix header file transition link: the legacy name for
      /usr/include/xmlrpc-c/server_abyss.h is xmlrpc_abyss.h, not
      xmlrpc_server_abyss.h (LP: #134529).
    -> Ship xmlrpc and its documentation (LP: #134985).

 -- Jeremie Corbier <jcorbier@ubuntu.com>  Mon, 27 Aug 2007 15:44:57 -0700

xmlrpc-c (1.06.17-0ubuntu3) gutsy; urgency=low

  * The WTF release.
  * Properly install files, including manpages (LP: #133766).

 -- Jeremie Corbier <jcorbier@ubuntu.com>  Tue, 21 Aug 2007 13:51:25 -0700

xmlrpc-c (1.06.17-0ubuntu2) gutsy; urgency=low

  * debian/rules: Add $(MAKE) CADD=-fPIC for AMD64 FTBFS

 -- Barry deFreese <bddebian@comcast.net>  Mon, 13 Aug 2007 10:49:33 -0400

xmlrpc-c (1.06.17-0ubuntu1) gutsy; urgency=low

  * New upstream version.  (LP: #61682)
  * debian/control
    - Updated Maintainer value to match Debian-Maintainer-Field Spec.
    - Changed ${Source-Version} to ${binary:Version} (safely binNMUable).
    - Fixed typo (description-synopsis-might-not-be-phrased-properly).
  * Use of debian/compat instead of DH_COMPAT.
    - debian/compat: Updated.
    - debian/rules: Removed 'export DH_COMPAT=3'
  * debian/rules
    - Updated to work with new upstream version.
  * debian/libxmlrpc-c3-dev.docs
    - Updated documentation available.

 -- Miguel Ruiz <mruiz@ubuntu.com>  Sun, 12 Aug 2007 19:17:06 -0400

xmlrpc-c (0.9.10-4) unstable; urgency=low

  * Fixed timestamps on build files (closes: Bug#229456)

 -- Chris Leishman <masklin@debian.org>  Wed, 17 Mar 2004 21:50:18 +1100

xmlrpc-c (0.9.10-3) unstable; urgency=low

  * Updated libtool (closes: Bug#201940)

 -- Chris Leishman <masklin@debian.org>  Mon,  8 Dec 2003 16:47:30 +1100

xmlrpc-c (0.9.10-2) unstable; urgency=low

  * g++ 3.2 compatability fixes (closes: Bug#177741)

 -- Chris Leishman <masklin@debian.org>  Fri, 4 Mar 2003 11:37:12 +0300

xmlrpc-c (0.9.10-1) unstable; urgency=low

  * Upstream version 0.9.10
  * Updated config.sub and config.guess (closes: Bug#166820)

 -- Chris Leishman <masklin@debian.org>  Fri, 17 Jan 2003 01:01:22 +0300

xmlrpc-c (0.9.9-5) unstable; urgency=low

  * Added conflict against libxmlrpc-c0 (closes: Bug#155050)
  * Installed overview.txt into /usr/share/doc (closes: Bug#153223)

 -- Chris Leishman <masklin@debian.org>  Mon, 5 Aug 2002 14:51:22 +0300

xmlrpc-c (0.9.9-4) unstable; urgency=low

  * Changed package names to libxmlrpc-c3(-dev) (closes: Bug#147739)
  * Added depend on libwww-dev to libxmlrpc-c0-dev (closes: Bug#147353)

 -- Chris Leishman <masklin@debian.org>  Thu, 30 May 2002 10:24:31 +1000

xmlrpc-c (0.9.9-3) unstable; urgency=low

  * Updates for gcc-3.0 compatability (closes: Bug#111392)
  * Updated config.guess & friends.

 -- Chris Leishman <masklin@debian.org>  Tue, 25 Sep 2001 02:01:31 -0700

xmlrpc-c (0.9.9-2) unstable; urgency=low

  * Fixed some issues in xmlrpc.h

 -- Chris Leishman <masklin@debian.org>  Wed, 29 Aug 2001 09:57:52 -0700

xmlrpc-c (0.9.9-1) unstable; urgency=low

  * Initial release.

 -- Chris Leishman <masklin@debian.org>  Thu, 16 Aug 2001 13:50:52 +1000

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: xmlrpc-c
Priority: optional
Section: libs
Maintainer: Sampo Savola <samposav@paju.oulu.fi>
XSBC-Original-Maintainer: Sean Finney <seanius@debian.org>
Build-Depends: autotools-dev, debhelper, libcurl4-openssl-dev | libcurl3-openssl-dev, quilt
Standards-Version: 3.7.3

Package: libxmlrpc-c3-dev
Section: libdevel
Architecture: any
Depends: libxmlrpc-c3 (= ${binary:Version}), libc6-dev, libwww-dev
Provides: libxmlrpc-c-dev
Conflicts: libxmlrpc-c-dev, libxmlrpc-c0-dev, xmlrpc-c-dev, libxmlrpc++-dev
Replaces: libxmlrpc-c-dev
Suggests: xml-rpc-api2cpp, xml-rpc-api2txt
Description: A lightweight RPC library based on XML and HTTP for C and C++
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides a modular implementation of XML-RPC for C and C++.
 .
 Install this package if you wish to develop your own programs using this
 library.
 .
 xmlrpc-c homepage: http://xmlrpc-c.sourceforge.net/

Package: libxmlrpc-c3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: libxmlrpc-c0, xmlrpc-c0, libwww-ssl0
Description: A lightweight RPC library based on XML and HTTP for C and C++
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides a modular implementation of XML-RPC for C and C++.
 .
 xmlrpc-c homepage: http://xmlrpc-c.sourceforge.net/

Package: xml-rpc-api2cpp
Architecture: any
Section: devel
Depends: libxmlrpc-c3 (= ${binary:Version}), libc6-dev
Description: Generate C++ wrapper classes for XML-RPC servers
 A utility for generating C++ wrapper classes based on an XML-RPC API,
 obtained by interrogating an XML-RPC server.
 .
 xmlrpc-c homepage: http://xmlrpc-c.sourceforge.net/

Package: xml-rpc-api2txt
Architecture: any
Section: devel
Depends: libxmlrpc-c3 (= ${binary:Version}), libc6-dev, libfrontier-rpc-perl
Description: Dump an XML-RPC API as a text file
 A utility for printing out an XML-RPC API as a text file.  The API is
 obtained by interrogating an XML-RPC server.
 .
 xmlrpc-c homepage: http://xmlrpc-c.sourceforge.net/

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1



# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --build $(DEB_BUILD_GNU_TYPE)
else
  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -O0
else
  CFLAGS += -O2
endif

# include the patch/unpatch rules from quilt
include /usr/share/quilt/quilt.make

muckfiles:=config.sub config.guess

config.status: configure $(QUILT_STAMPFN)
	dh_testdir
	# backup files that either we or upstream muck with
	for f in $(muckfiles); do cp -a $$f $$f.orig; done
	ln -sf /usr/share/misc/config.sub config.sub
	ln -sf /usr/share/misc/config.guess config.guess
	./configure $(confflags) \
	            --prefix=/usr \
		    --mandir=\$${prefix}/share/man \
		    --infodir=\$${prefix}/share/info


build: build-arch-stamp build-indep-stamp

build-arch: build-arch-stamp
build-arch-stamp: config.status
	dh_testdir
	$(MAKE) CADD=-fPIC
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: config.status
	dh_testdir
	# nothing to build
	touch build-indep-stamp

clean: unpatch
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp
	# Add here commands to clean up after the build process.
	# xxx upstream build process still breaks on distclean...
	[ ! -f Makefile ] || [ ! -f config.status ] || $(MAKE) distclean || true
	# restore files mucked by us or upstream during build/clean
	for f in $(muckfiles); do \
		[ ! -e $$f.orig ] || ( rm -rf $$f; mv $$f.orig $$f ) ; \
	done
	dh_clean -X autom4te.cache

#install: install-indep install-arch
install: install-arch

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_clean -k -a
	dh_installdirs -a

	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

	dh_install -a --list-missing
	# plop in our lintian override file
	mkdir -p debian/libxmlrpc-c3/usr/share/lintian/overrides/
	cp debian/xmlrpc-c.lintian-overrides debian/libxmlrpc-c3/usr/share/lintian/overrides/libxmlrpc-c3

install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_clean -k -i
	dh_installdirs -i
	dh_install -i --list-missing


# Common target for binary-indep/binary-arch.  Must not depend on anything and
# will get called by another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
	dh_makeshlibs
	dh_shlibdeps
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

#binary: binary-indep binary-arch
binary: binary-arch

# Build architecture-independent files using the common target.
binary-indep: install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture-dependent files using the common target.
binary-arch: install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

.PHONY: build clean install install-indep install-arch install binary binary-common binary-indep binary-arch
